import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "igniteui-react-core";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-react-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected cd(): SeriesView;
    nh(): void;
    o2(a: SeriesView): void;
    vs: ScatterBaseView;
    protected get_fa(): boolean;
    ag(): Axis[];
    jv(a: any, b: string): any;
    dt(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    protected bu(): SeriesHitTestMode;
    tw(a: Point): Rect;
    f5(a: Point, b: boolean): boolean;
    constructor();
    vr: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    xn: string;
    get wc(): IFastItemColumn$1<number>;
    set wc(a: IFastItemColumn$1<number>);
    private wa;
    xv: string;
    get wd(): IFastItemColumn$1<number>;
    set wd(a: IFastItemColumn$1<number>);
    private wb;
    w7: string;
    w9: string;
    protected fo(): boolean;
    protected wr(): boolean;
    protected g1(): List$1<SeriesLayerPropertyOverlay>;
    private x1;
    private x2;
    xj: string;
    xr: string;
    xl: string;
    xt: string;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get zb(): Brush;
    set zb(a: Brush);
    static readonly ym: DependencyProperty;
    trendLineThickness: number;
    zd: PenLineCap;
    zc: DoubleCollection;
    trendLinePeriod: number;
    vo: CollisionAvoidanceType;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    w4: number;
    w3: number;
    v3: ScatterItemSearchMode;
    w2: number;
    oc(): void;
    vt: ScatterErrorBarSettings;
    protected pa(a: any, b: string, c: any, d: any): void;
    protected wo(): boolean;
    protected wn(): boolean;
    wi(a: any): boolean;
    wh(a: any): boolean;
    private yk;
    private ze;
    private zf;
    private xx;
    protected wm(a: string, b: FastItemsSourceEventAction): boolean;
    protected np(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    yb(a: ScatterFrame): void;
    yc(a: ScatterFrame, b: Clipper): void;
    aq(a: Axis): AxisRange;
    js(a: Point): any;
    private v0;
    get v1(): ScatterItemSearchMode;
    set v1(a: ScatterItemSearchMode);
    protected v2(): ScatterItemSearchMode;
    i9(a: Point): number;
    hw(a: Point): number;
    protected wy(a: Point): number;
    private vh;
    private vi;
    protected wx(a: Point): number;
    private x0;
    protected get_wl(): boolean;
    protected get wl(): boolean;
    private w1;
    protected w0(a: Point): number;
    protected wz(a: Point): number;
    tj(a: Point, b: boolean, c: boolean): Point;
    fp(a: any): boolean;
    protected qo(a: Rect, b: Rect): void;
    protected qp(a: Rect, b: Rect): void;
    vx: ScatterFrame;
    vz: ScatterFrame;
    vv: ScatterFrame;
    vw(): ScatterFrame;
    xy(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    x8(a: ScatterFrame, b: ScatterBaseView): void;
    nk(a: boolean, b: SeriesView): void;
    wk: boolean;
    wj: boolean;
    protected wg: boolean;
    protected wf: boolean;
    protected get_et(): boolean;
    private v8;
    private v9;
    protected v6(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected v7(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    t0(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected v5(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    c0(a: any, b: Point, c: boolean): HighlightingInfo;
    c1(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    protected wq(): boolean;
    protected wp(): boolean;
    yj(a: ScatterFrame, b: ScatterBaseView): void;
    vk(a: number, b: number): any[];
    protected vl(a: number, b: number): any[];
    protected v4: ScatterSeriesRenderManager;
    xz(a: ScatterBaseView, b: ScatterFrame): void;
    protected x4(a: number, b: number, c: boolean): void;
    protected x3(a: number, b: number, c: boolean): void;
    protected ye(a: AssigningScatterStyleEventArgs): void;
    protected yd(a: AssigningScatterMarkerStyleEventArgs): void;
    x6(a: ScatterFrame, b: ScatterBaseView): void;
    x9(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    x7(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    x5(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    ya(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    yg(a: ScatterFrame, b: ScatterBaseView): void;
    private yh;
    private yi;
    gm(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    ps(a: boolean): void;
    protected qf(): void;
    vy: ScatterFrame;
    pt(a: Rect, b: RenderSurface): void;
    private vu;
    pq(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    yf(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    vj(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    ws(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected n2(a: any): void;
    h3(): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    private we;
    private wt;
    private wu;
    wv: number;
    ww: number;
    private yl;
    id(a: ValueLayerValueMode, b: Axis): number;
    am(a: ValueLayerValueMode): number[];
    tn(a: number[]): Point;
    tm(a: ValueLayerValueMode): Point;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningScatterMarkerStyleEventArgs;
    ax: AssigningScatterStyleEventArgs;
    ay(a: ScatterBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    cy: MarkerManagerBase;
    protected cw: Point[];
    protected cz: ScatterBase;
    protected c4: List$1<number>;
    constructor(a: ScatterBase);
    private df;
    private dg;
    c0: ScatterTrendLineManager;
    au(): void;
    private de;
    dh(a: Marker): Size;
    protected cx(): MarkerManagerBase;
    protected dc(a: IDictionary$2<any, OwnedPoint>): void;
    c3(): List$1<Marker>;
    cv(): Point[];
    protected cu(): Point[];
    protected c2(): List$1<number>;
    c5(): void;
    da(a: PathGeometry): void;
    c6(): void;
    db(a: PathGeometry): void;
    dd(): void;
    c1: HashPool$2<any, Marker>;
    ci(a: (arg1: Marker) => void): void;
    c8(a: (arg1: Marker) => void): void;
    c9(): void;
    protected a7(a: RenderingContext, b: boolean): void;
    c7(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
